// QuickSort demonstration
// Written by J. Farrell
// jdfarrell@students.wisc.edu

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>

// Prototypes
void quicksort(int, int); // QuickSort function
void swap_int(int, int);  // Swaps array[n1] with array[n2]

// Globals
int array[400];

void main(void)
{
  int a;

  // Make an array of random integers from 1-100
  randomize();
  for (a=0; a<400; a++)
    array[a] = random(100);

  clrscr();
  printf("Sorting...");
  quicksort(0,399);
  printf("...wow, that was fast!\n");
  for (a=0; a<400; a++)
    printf("%d ",array[a]);
  getch();
}

void quicksort(int low, int high)
{
  // Initialize pointers
  int top = low,
      bottom = high - 1,
      part_index,
      part_value;

  // Do nothing if low >= high
  if (low < high)
  {
    // Check if elements are sequential
    if (high == (low + 1))
    {
      if (array[low] > array[high])
	swap_int(high, low);
    }
    else
    {
      // Choose a partition element and swap it with the last value in
      // the array
      part_index = (int)((low + high) / 2);
      part_value = array[part_index];
      swap_int(high, part_index);

      do
      {
	// Inrement the top pointer
	while ((array[top] <= part_value) && (top <= bottom))
	  top++;
	// Decrement the bottom pointer
	while ((array[bottom] > part_value) && (top <= bottom))
	  bottom--;
	// Swap elements if pointers have not met
	if (top < bottom)
	  swap_int(top, bottom);
      } while (top < bottom);

      // Put the partition element back where it belongs
      swap_int(top, high);

      // Recursive calls
      quicksort(low, top - 1);
      quicksort(top + 1, high);
    }
  }
}

// Swaps array[n1] with array[n2]
void swap_int(int n1, int n2)
{
  int temp;

  temp = array[n1];
  array[n1] = array[n2];
  array[n2] = temp;
}